// Code generated by ent, DO NOT EDIT.

package ent

import (
	"context"
	"fmt"
	"math"

	"entgo.io/ent/dialect/sql"
	"entgo.io/ent/dialect/sql/sqlgraph"
	"entgo.io/ent/schema/field"
	"go.phucam.tv/ent/predicate"
	"go.phucam.tv/ent/user"
	"go.phucam.tv/ent/useremail"
)

// UserEmailQuery is the builder for querying UserEmail entities.
type UserEmailQuery struct {
	config
	limit      *int
	offset     *int
	unique     *bool
	order      []OrderFunc
	fields     []string
	predicates []predicate.UserEmail
	// eager-loading edges.
	withUser *UserQuery
	withFKs  bool
	// intermediate query (i.e. traversal path).
	sql  *sql.Selector
	path func(context.Context) (*sql.Selector, error)
}

// Where adds a new predicate for the UserEmailQuery builder.
func (ueq *UserEmailQuery) Where(ps ...predicate.UserEmail) *UserEmailQuery {
	ueq.predicates = append(ueq.predicates, ps...)
	return ueq
}

// Limit adds a limit step to the query.
func (ueq *UserEmailQuery) Limit(limit int) *UserEmailQuery {
	ueq.limit = &limit
	return ueq
}

// Offset adds an offset step to the query.
func (ueq *UserEmailQuery) Offset(offset int) *UserEmailQuery {
	ueq.offset = &offset
	return ueq
}

// Unique configures the query builder to filter duplicate records on query.
// By default, unique is set to true, and can be disabled using this method.
func (ueq *UserEmailQuery) Unique(unique bool) *UserEmailQuery {
	ueq.unique = &unique
	return ueq
}

// Order adds an order step to the query.
func (ueq *UserEmailQuery) Order(o ...OrderFunc) *UserEmailQuery {
	ueq.order = append(ueq.order, o...)
	return ueq
}

// QueryUser chains the current query on the "user" edge.
func (ueq *UserEmailQuery) QueryUser() *UserQuery {
	query := &UserQuery{config: ueq.config}
	query.path = func(ctx context.Context) (fromU *sql.Selector, err error) {
		if err := ueq.prepareQuery(ctx); err != nil {
			return nil, err
		}
		selector := ueq.sqlQuery(ctx)
		if err := selector.Err(); err != nil {
			return nil, err
		}
		step := sqlgraph.NewStep(
			sqlgraph.From(useremail.Table, useremail.FieldID, selector),
			sqlgraph.To(user.Table, user.FieldID),
			sqlgraph.Edge(sqlgraph.M2O, true, useremail.UserTable, useremail.UserColumn),
		)
		fromU = sqlgraph.SetNeighbors(ueq.driver.Dialect(), step)
		return fromU, nil
	}
	return query
}

// First returns the first UserEmail entity from the query.
// Returns a *NotFoundError when no UserEmail was found.
func (ueq *UserEmailQuery) First(ctx context.Context) (*UserEmail, error) {
	nodes, err := ueq.Limit(1).All(ctx)
	if err != nil {
		return nil, err
	}
	if len(nodes) == 0 {
		return nil, &NotFoundError{useremail.Label}
	}
	return nodes[0], nil
}

// FirstX is like First, but panics if an error occurs.
func (ueq *UserEmailQuery) FirstX(ctx context.Context) *UserEmail {
	node, err := ueq.First(ctx)
	if err != nil && !IsNotFound(err) {
		panic(err)
	}
	return node
}

// FirstID returns the first UserEmail ID from the query.
// Returns a *NotFoundError when no UserEmail ID was found.
func (ueq *UserEmailQuery) FirstID(ctx context.Context) (id int, err error) {
	var ids []int
	if ids, err = ueq.Limit(1).IDs(ctx); err != nil {
		return
	}
	if len(ids) == 0 {
		err = &NotFoundError{useremail.Label}
		return
	}
	return ids[0], nil
}

// FirstIDX is like FirstID, but panics if an error occurs.
func (ueq *UserEmailQuery) FirstIDX(ctx context.Context) int {
	id, err := ueq.FirstID(ctx)
	if err != nil && !IsNotFound(err) {
		panic(err)
	}
	return id
}

// Only returns a single UserEmail entity found by the query, ensuring it only returns one.
// Returns a *NotSingularError when more than one UserEmail entity is found.
// Returns a *NotFoundError when no UserEmail entities are found.
func (ueq *UserEmailQuery) Only(ctx context.Context) (*UserEmail, error) {
	nodes, err := ueq.Limit(2).All(ctx)
	if err != nil {
		return nil, err
	}
	switch len(nodes) {
	case 1:
		return nodes[0], nil
	case 0:
		return nil, &NotFoundError{useremail.Label}
	default:
		return nil, &NotSingularError{useremail.Label}
	}
}

// OnlyX is like Only, but panics if an error occurs.
func (ueq *UserEmailQuery) OnlyX(ctx context.Context) *UserEmail {
	node, err := ueq.Only(ctx)
	if err != nil {
		panic(err)
	}
	return node
}

// OnlyID is like Only, but returns the only UserEmail ID in the query.
// Returns a *NotSingularError when more than one UserEmail ID is found.
// Returns a *NotFoundError when no entities are found.
func (ueq *UserEmailQuery) OnlyID(ctx context.Context) (id int, err error) {
	var ids []int
	if ids, err = ueq.Limit(2).IDs(ctx); err != nil {
		return
	}
	switch len(ids) {
	case 1:
		id = ids[0]
	case 0:
		err = &NotFoundError{useremail.Label}
	default:
		err = &NotSingularError{useremail.Label}
	}
	return
}

// OnlyIDX is like OnlyID, but panics if an error occurs.
func (ueq *UserEmailQuery) OnlyIDX(ctx context.Context) int {
	id, err := ueq.OnlyID(ctx)
	if err != nil {
		panic(err)
	}
	return id
}

// All executes the query and returns a list of UserEmails.
func (ueq *UserEmailQuery) All(ctx context.Context) ([]*UserEmail, error) {
	if err := ueq.prepareQuery(ctx); err != nil {
		return nil, err
	}
	return ueq.sqlAll(ctx)
}

// AllX is like All, but panics if an error occurs.
func (ueq *UserEmailQuery) AllX(ctx context.Context) []*UserEmail {
	nodes, err := ueq.All(ctx)
	if err != nil {
		panic(err)
	}
	return nodes
}

// IDs executes the query and returns a list of UserEmail IDs.
func (ueq *UserEmailQuery) IDs(ctx context.Context) ([]int, error) {
	var ids []int
	if err := ueq.Select(useremail.FieldID).Scan(ctx, &ids); err != nil {
		return nil, err
	}
	return ids, nil
}

// IDsX is like IDs, but panics if an error occurs.
func (ueq *UserEmailQuery) IDsX(ctx context.Context) []int {
	ids, err := ueq.IDs(ctx)
	if err != nil {
		panic(err)
	}
	return ids
}

// Count returns the count of the given query.
func (ueq *UserEmailQuery) Count(ctx context.Context) (int, error) {
	if err := ueq.prepareQuery(ctx); err != nil {
		return 0, err
	}
	return ueq.sqlCount(ctx)
}

// CountX is like Count, but panics if an error occurs.
func (ueq *UserEmailQuery) CountX(ctx context.Context) int {
	count, err := ueq.Count(ctx)
	if err != nil {
		panic(err)
	}
	return count
}

// Exist returns true if the query has elements in the graph.
func (ueq *UserEmailQuery) Exist(ctx context.Context) (bool, error) {
	if err := ueq.prepareQuery(ctx); err != nil {
		return false, err
	}
	return ueq.sqlExist(ctx)
}

// ExistX is like Exist, but panics if an error occurs.
func (ueq *UserEmailQuery) ExistX(ctx context.Context) bool {
	exist, err := ueq.Exist(ctx)
	if err != nil {
		panic(err)
	}
	return exist
}

// Clone returns a duplicate of the UserEmailQuery builder, including all associated steps. It can be
// used to prepare common query builders and use them differently after the clone is made.
func (ueq *UserEmailQuery) Clone() *UserEmailQuery {
	if ueq == nil {
		return nil
	}
	return &UserEmailQuery{
		config:     ueq.config,
		limit:      ueq.limit,
		offset:     ueq.offset,
		order:      append([]OrderFunc{}, ueq.order...),
		predicates: append([]predicate.UserEmail{}, ueq.predicates...),
		withUser:   ueq.withUser.Clone(),
		// clone intermediate query.
		sql:    ueq.sql.Clone(),
		path:   ueq.path,
		unique: ueq.unique,
	}
}

// WithUser tells the query-builder to eager-load the nodes that are connected to
// the "user" edge. The optional arguments are used to configure the query builder of the edge.
func (ueq *UserEmailQuery) WithUser(opts ...func(*UserQuery)) *UserEmailQuery {
	query := &UserQuery{config: ueq.config}
	for _, opt := range opts {
		opt(query)
	}
	ueq.withUser = query
	return ueq
}

// GroupBy is used to group vertices by one or more fields/columns.
// It is often used with aggregate functions, like: count, max, mean, min, sum.
//
// Example:
//
//	var v []struct {
//		Value string `json:"value,omitempty"`
//		Count int `json:"count,omitempty"`
//	}
//
//	client.UserEmail.Query().
//		GroupBy(useremail.FieldValue).
//		Aggregate(ent.Count()).
//		Scan(ctx, &v)
//
func (ueq *UserEmailQuery) GroupBy(field string, fields ...string) *UserEmailGroupBy {
	grbuild := &UserEmailGroupBy{config: ueq.config}
	grbuild.fields = append([]string{field}, fields...)
	grbuild.path = func(ctx context.Context) (prev *sql.Selector, err error) {
		if err := ueq.prepareQuery(ctx); err != nil {
			return nil, err
		}
		return ueq.sqlQuery(ctx), nil
	}
	grbuild.label = useremail.Label
	grbuild.flds, grbuild.scan = &grbuild.fields, grbuild.Scan
	return grbuild
}

// Select allows the selection one or more fields/columns for the given query,
// instead of selecting all fields in the entity.
//
// Example:
//
//	var v []struct {
//		Value string `json:"value,omitempty"`
//	}
//
//	client.UserEmail.Query().
//		Select(useremail.FieldValue).
//		Scan(ctx, &v)
//
func (ueq *UserEmailQuery) Select(fields ...string) *UserEmailSelect {
	ueq.fields = append(ueq.fields, fields...)
	selbuild := &UserEmailSelect{UserEmailQuery: ueq}
	selbuild.label = useremail.Label
	selbuild.flds, selbuild.scan = &ueq.fields, selbuild.Scan
	return selbuild
}

func (ueq *UserEmailQuery) prepareQuery(ctx context.Context) error {
	for _, f := range ueq.fields {
		if !useremail.ValidColumn(f) {
			return &ValidationError{Name: f, err: fmt.Errorf("ent: invalid field %q for query", f)}
		}
	}
	if ueq.path != nil {
		prev, err := ueq.path(ctx)
		if err != nil {
			return err
		}
		ueq.sql = prev
	}
	return nil
}

func (ueq *UserEmailQuery) sqlAll(ctx context.Context, hooks ...queryHook) ([]*UserEmail, error) {
	var (
		nodes       = []*UserEmail{}
		withFKs     = ueq.withFKs
		_spec       = ueq.querySpec()
		loadedTypes = [1]bool{
			ueq.withUser != nil,
		}
	)
	if ueq.withUser != nil {
		withFKs = true
	}
	if withFKs {
		_spec.Node.Columns = append(_spec.Node.Columns, useremail.ForeignKeys...)
	}
	_spec.ScanValues = func(columns []string) ([]interface{}, error) {
		return (*UserEmail).scanValues(nil, columns)
	}
	_spec.Assign = func(columns []string, values []interface{}) error {
		node := &UserEmail{config: ueq.config}
		nodes = append(nodes, node)
		node.Edges.loadedTypes = loadedTypes
		return node.assignValues(columns, values)
	}
	for i := range hooks {
		hooks[i](ctx, _spec)
	}
	if err := sqlgraph.QueryNodes(ctx, ueq.driver, _spec); err != nil {
		return nil, err
	}
	if len(nodes) == 0 {
		return nodes, nil
	}

	if query := ueq.withUser; query != nil {
		ids := make([]int, 0, len(nodes))
		nodeids := make(map[int][]*UserEmail)
		for i := range nodes {
			if nodes[i].user_emails == nil {
				continue
			}
			fk := *nodes[i].user_emails
			if _, ok := nodeids[fk]; !ok {
				ids = append(ids, fk)
			}
			nodeids[fk] = append(nodeids[fk], nodes[i])
		}
		query.Where(user.IDIn(ids...))
		neighbors, err := query.All(ctx)
		if err != nil {
			return nil, err
		}
		for _, n := range neighbors {
			nodes, ok := nodeids[n.ID]
			if !ok {
				return nil, fmt.Errorf(`unexpected foreign-key "user_emails" returned %v`, n.ID)
			}
			for i := range nodes {
				nodes[i].Edges.User = n
			}
		}
	}

	return nodes, nil
}

func (ueq *UserEmailQuery) sqlCount(ctx context.Context) (int, error) {
	_spec := ueq.querySpec()
	_spec.Node.Columns = ueq.fields
	if len(ueq.fields) > 0 {
		_spec.Unique = ueq.unique != nil && *ueq.unique
	}
	return sqlgraph.CountNodes(ctx, ueq.driver, _spec)
}

func (ueq *UserEmailQuery) sqlExist(ctx context.Context) (bool, error) {
	n, err := ueq.sqlCount(ctx)
	if err != nil {
		return false, fmt.Errorf("ent: check existence: %w", err)
	}
	return n > 0, nil
}

func (ueq *UserEmailQuery) querySpec() *sqlgraph.QuerySpec {
	_spec := &sqlgraph.QuerySpec{
		Node: &sqlgraph.NodeSpec{
			Table:   useremail.Table,
			Columns: useremail.Columns,
			ID: &sqlgraph.FieldSpec{
				Type:   field.TypeInt,
				Column: useremail.FieldID,
			},
		},
		From:   ueq.sql,
		Unique: true,
	}
	if unique := ueq.unique; unique != nil {
		_spec.Unique = *unique
	}
	if fields := ueq.fields; len(fields) > 0 {
		_spec.Node.Columns = make([]string, 0, len(fields))
		_spec.Node.Columns = append(_spec.Node.Columns, useremail.FieldID)
		for i := range fields {
			if fields[i] != useremail.FieldID {
				_spec.Node.Columns = append(_spec.Node.Columns, fields[i])
			}
		}
	}
	if ps := ueq.predicates; len(ps) > 0 {
		_spec.Predicate = func(selector *sql.Selector) {
			for i := range ps {
				ps[i](selector)
			}
		}
	}
	if limit := ueq.limit; limit != nil {
		_spec.Limit = *limit
	}
	if offset := ueq.offset; offset != nil {
		_spec.Offset = *offset
	}
	if ps := ueq.order; len(ps) > 0 {
		_spec.Order = func(selector *sql.Selector) {
			for i := range ps {
				ps[i](selector)
			}
		}
	}
	return _spec
}

func (ueq *UserEmailQuery) sqlQuery(ctx context.Context) *sql.Selector {
	builder := sql.Dialect(ueq.driver.Dialect())
	t1 := builder.Table(useremail.Table)
	columns := ueq.fields
	if len(columns) == 0 {
		columns = useremail.Columns
	}
	selector := builder.Select(t1.Columns(columns...)...).From(t1)
	if ueq.sql != nil {
		selector = ueq.sql
		selector.Select(selector.Columns(columns...)...)
	}
	if ueq.unique != nil && *ueq.unique {
		selector.Distinct()
	}
	for _, p := range ueq.predicates {
		p(selector)
	}
	for _, p := range ueq.order {
		p(selector)
	}
	if offset := ueq.offset; offset != nil {
		// limit is mandatory for offset clause. We start
		// with default value, and override it below if needed.
		selector.Offset(*offset).Limit(math.MaxInt32)
	}
	if limit := ueq.limit; limit != nil {
		selector.Limit(*limit)
	}
	return selector
}

// UserEmailGroupBy is the group-by builder for UserEmail entities.
type UserEmailGroupBy struct {
	config
	selector
	fields []string
	fns    []AggregateFunc
	// intermediate query (i.e. traversal path).
	sql  *sql.Selector
	path func(context.Context) (*sql.Selector, error)
}

// Aggregate adds the given aggregation functions to the group-by query.
func (uegb *UserEmailGroupBy) Aggregate(fns ...AggregateFunc) *UserEmailGroupBy {
	uegb.fns = append(uegb.fns, fns...)
	return uegb
}

// Scan applies the group-by query and scans the result into the given value.
func (uegb *UserEmailGroupBy) Scan(ctx context.Context, v interface{}) error {
	query, err := uegb.path(ctx)
	if err != nil {
		return err
	}
	uegb.sql = query
	return uegb.sqlScan(ctx, v)
}

func (uegb *UserEmailGroupBy) sqlScan(ctx context.Context, v interface{}) error {
	for _, f := range uegb.fields {
		if !useremail.ValidColumn(f) {
			return &ValidationError{Name: f, err: fmt.Errorf("invalid field %q for group-by", f)}
		}
	}
	selector := uegb.sqlQuery()
	if err := selector.Err(); err != nil {
		return err
	}
	rows := &sql.Rows{}
	query, args := selector.Query()
	if err := uegb.driver.Query(ctx, query, args, rows); err != nil {
		return err
	}
	defer rows.Close()
	return sql.ScanSlice(rows, v)
}

func (uegb *UserEmailGroupBy) sqlQuery() *sql.Selector {
	selector := uegb.sql.Select()
	aggregation := make([]string, 0, len(uegb.fns))
	for _, fn := range uegb.fns {
		aggregation = append(aggregation, fn(selector))
	}
	// If no columns were selected in a custom aggregation function, the default
	// selection is the fields used for "group-by", and the aggregation functions.
	if len(selector.SelectedColumns()) == 0 {
		columns := make([]string, 0, len(uegb.fields)+len(uegb.fns))
		for _, f := range uegb.fields {
			columns = append(columns, selector.C(f))
		}
		columns = append(columns, aggregation...)
		selector.Select(columns...)
	}
	return selector.GroupBy(selector.Columns(uegb.fields...)...)
}

// UserEmailSelect is the builder for selecting fields of UserEmail entities.
type UserEmailSelect struct {
	*UserEmailQuery
	selector
	// intermediate query (i.e. traversal path).
	sql *sql.Selector
}

// Scan applies the selector query and scans the result into the given value.
func (ues *UserEmailSelect) Scan(ctx context.Context, v interface{}) error {
	if err := ues.prepareQuery(ctx); err != nil {
		return err
	}
	ues.sql = ues.UserEmailQuery.sqlQuery(ctx)
	return ues.sqlScan(ctx, v)
}

func (ues *UserEmailSelect) sqlScan(ctx context.Context, v interface{}) error {
	rows := &sql.Rows{}
	query, args := ues.sql.Query()
	if err := ues.driver.Query(ctx, query, args, rows); err != nil {
		return err
	}
	defer rows.Close()
	return sql.ScanSlice(rows, v)
}
